/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIProgressDialog.idl
 */

#ifndef __gen_nsIProgressDialog_h__
#define __gen_nsIProgressDialog_h__


#ifndef __gen_nsIWebProgressListener_h__
#include "nsIWebProgressListener.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIWebBrowserPersist; /* forward declaration */

class nsIDOMWindow; /* forward declaration */

class nsILocalFile; /* forward declaration */

class nsIObserver; /* forward declaration */


/* starting interface:    nsIProgressDialog */
#define NS_IPROGRESSDIALOG_IID_STR "88a478b3-af65-440a-94dc-ed9b154d2990"

#define NS_IPROGRESSDIALOG_IID \
  {0x88a478b3, 0xaf65, 0x440a, \
    { 0x94, 0xdc, 0xed, 0x9b, 0x15, 0x4d, 0x29, 0x90 }}

class NS_NO_VTABLE nsIProgressDialog : public nsIWebProgressListener {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IPROGRESSDIALOG_IID)

  /**
    * Open the dialog
    *
    * @param aParent  Parent window; optional (if null, then
    *                 a top-level window is created)
    * @param aPersist The stream transfer operation that the dialog is
    *                 to show progress for.  This is optional.  If
    *                 specified, then the progress dialog will register
    *                 itself as the listener for that object.  Otherwise,
    *                 it is the caller's responsibility to connect this
    *                 object to something that sends out the web progress
    *                 notifications.
    */
  /* void open (in nsIDOMWindow aParent, in nsIWebBrowserPersist aPersist); */
  NS_IMETHOD Open(nsIDOMWindow *aParent, nsIWebBrowserPersist *aPersist) = 0;

  /**
    * Set starting time to use in elapsed/remaining time calculations;
    * this is useful in cases where the download might have started
    * prior to the dialog opening; the time is specified as
    * milliseconds, according to the convention for the JavaScript Date 
    * object getTime function; if not specified, this value will default
    * to the time at which the progress dialog object is created.
    */
  /* attribute long long startTime; */
  NS_IMETHOD GetStartTime(PRInt64 *aStartTime) = 0;
  NS_IMETHOD SetStartTime(PRInt64 aStartTime) = 0;

  /**
    * URL of the source of the stream transfer that the dialog is 
    * displaying the progress of.
    */
  /* attribute nsIURI source; */
  NS_IMETHOD GetSource(nsIURI * *aSource) = 0;
  NS_IMETHOD SetSource(nsIURI * aSource) = 0;

  /**
    * Target of the stream transfer that the dialog is
    * displaying the progress of.
    */
  /* attribute nsILocalFile target; */
  NS_IMETHOD GetTarget(nsILocalFile * *aTarget) = 0;
  NS_IMETHOD SetTarget(nsILocalFile * aTarget) = 0;

  /**
    * Set this attribute to indicate that the dialog is being
    * used to display progress prior to opening a downloaded
    * file with a helper application.  The application string
    * specified will appear on the dialog, unless the string
    * is empty.  This will also cause the "keep this dialog
    * open after download" checkbox hidden.
    */
  /* attribute wstring openingWith; */
  NS_IMETHOD GetOpeningWith(PRUnichar * *aOpeningWith) = 0;
  NS_IMETHOD SetOpeningWith(const PRUnichar * aOpeningWith) = 0;

  /**
    * Set this attribute to the observer object that will be
    * notified when the user presses the Cancel button.  The
    * observer's "observe" method will be called with:
    *   aSubject = the nsIProgressDialog
    *   aTopic   = "oncancel"
    *   aData    = ""
    */
  /* attribute nsIObserver observer; */
  NS_IMETHOD GetObserver(nsIObserver * *aObserver) = 0;
  NS_IMETHOD SetObserver(nsIObserver * aObserver) = 0;

  /**
    * The web browser persist object doing the associated I/O.
    * May be null.
    */
  /* readonly attribute nsIWebBrowserPersist operation; */
  NS_IMETHOD GetOperation(nsIWebBrowserPersist * *aOperation) = 0;

  /**
    * The dialog object itself.  This might be null if the dialog isn't
    * open yet, or has been closed.
    */
  /* readonly attribute nsIDOMWindow dialog; */
  NS_IMETHOD GetDialog(nsIDOMWindow * *aDialog) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPROGRESSDIALOG \
  NS_IMETHOD Open(nsIDOMWindow *aParent, nsIWebBrowserPersist *aPersist); \
  NS_IMETHOD GetStartTime(PRInt64 *aStartTime); \
  NS_IMETHOD SetStartTime(PRInt64 aStartTime); \
  NS_IMETHOD GetSource(nsIURI * *aSource); \
  NS_IMETHOD SetSource(nsIURI * aSource); \
  NS_IMETHOD GetTarget(nsILocalFile * *aTarget); \
  NS_IMETHOD SetTarget(nsILocalFile * aTarget); \
  NS_IMETHOD GetOpeningWith(PRUnichar * *aOpeningWith); \
  NS_IMETHOD SetOpeningWith(const PRUnichar * aOpeningWith); \
  NS_IMETHOD GetObserver(nsIObserver * *aObserver); \
  NS_IMETHOD SetObserver(nsIObserver * aObserver); \
  NS_IMETHOD GetOperation(nsIWebBrowserPersist * *aOperation); \
  NS_IMETHOD GetDialog(nsIDOMWindow * *aDialog); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPROGRESSDIALOG(_to) \
  NS_IMETHOD Open(nsIDOMWindow *aParent, nsIWebBrowserPersist *aPersist) { return _to Open(aParent, aPersist); } \
  NS_IMETHOD GetStartTime(PRInt64 *aStartTime) { return _to GetStartTime(aStartTime); } \
  NS_IMETHOD SetStartTime(PRInt64 aStartTime) { return _to SetStartTime(aStartTime); } \
  NS_IMETHOD GetSource(nsIURI * *aSource) { return _to GetSource(aSource); } \
  NS_IMETHOD SetSource(nsIURI * aSource) { return _to SetSource(aSource); } \
  NS_IMETHOD GetTarget(nsILocalFile * *aTarget) { return _to GetTarget(aTarget); } \
  NS_IMETHOD SetTarget(nsILocalFile * aTarget) { return _to SetTarget(aTarget); } \
  NS_IMETHOD GetOpeningWith(PRUnichar * *aOpeningWith) { return _to GetOpeningWith(aOpeningWith); } \
  NS_IMETHOD SetOpeningWith(const PRUnichar * aOpeningWith) { return _to SetOpeningWith(aOpeningWith); } \
  NS_IMETHOD GetObserver(nsIObserver * *aObserver) { return _to GetObserver(aObserver); } \
  NS_IMETHOD SetObserver(nsIObserver * aObserver) { return _to SetObserver(aObserver); } \
  NS_IMETHOD GetOperation(nsIWebBrowserPersist * *aOperation) { return _to GetOperation(aOperation); } \
  NS_IMETHOD GetDialog(nsIDOMWindow * *aDialog) { return _to GetDialog(aDialog); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIPROGRESSDIALOG(_to) \
  NS_IMETHOD Open(nsIDOMWindow *aParent, nsIWebBrowserPersist *aPersist) { return !_to ? NS_ERROR_NULL_POINTER : _to->Open(aParent, aPersist); } \
  NS_IMETHOD GetStartTime(PRInt64 *aStartTime) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStartTime(aStartTime); } \
  NS_IMETHOD SetStartTime(PRInt64 aStartTime) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetStartTime(aStartTime); } \
  NS_IMETHOD GetSource(nsIURI * *aSource) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSource(aSource); } \
  NS_IMETHOD SetSource(nsIURI * aSource) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetSource(aSource); } \
  NS_IMETHOD GetTarget(nsILocalFile * *aTarget) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTarget(aTarget); } \
  NS_IMETHOD SetTarget(nsILocalFile * aTarget) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetTarget(aTarget); } \
  NS_IMETHOD GetOpeningWith(PRUnichar * *aOpeningWith) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetOpeningWith(aOpeningWith); } \
  NS_IMETHOD SetOpeningWith(const PRUnichar * aOpeningWith) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetOpeningWith(aOpeningWith); } \
  NS_IMETHOD GetObserver(nsIObserver * *aObserver) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetObserver(aObserver); } \
  NS_IMETHOD SetObserver(nsIObserver * aObserver) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetObserver(aObserver); } \
  NS_IMETHOD GetOperation(nsIWebBrowserPersist * *aOperation) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetOperation(aOperation); } \
  NS_IMETHOD GetDialog(nsIDOMWindow * *aDialog) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDialog(aDialog); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsProgressDialog : public nsIProgressDialog
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIPROGRESSDIALOG

  nsProgressDialog();
  virtual ~nsProgressDialog();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsProgressDialog, nsIProgressDialog)

nsProgressDialog::nsProgressDialog()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsProgressDialog::~nsProgressDialog()
{
  /* destructor code */
}

/* void open (in nsIDOMWindow aParent, in nsIWebBrowserPersist aPersist); */
NS_IMETHODIMP nsProgressDialog::Open(nsIDOMWindow *aParent, nsIWebBrowserPersist *aPersist)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute long long startTime; */
NS_IMETHODIMP nsProgressDialog::GetStartTime(PRInt64 *aStartTime)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsProgressDialog::SetStartTime(PRInt64 aStartTime)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIURI source; */
NS_IMETHODIMP nsProgressDialog::GetSource(nsIURI * *aSource)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsProgressDialog::SetSource(nsIURI * aSource)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsILocalFile target; */
NS_IMETHODIMP nsProgressDialog::GetTarget(nsILocalFile * *aTarget)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsProgressDialog::SetTarget(nsILocalFile * aTarget)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute wstring openingWith; */
NS_IMETHODIMP nsProgressDialog::GetOpeningWith(PRUnichar * *aOpeningWith)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsProgressDialog::SetOpeningWith(const PRUnichar * aOpeningWith)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIObserver observer; */
NS_IMETHODIMP nsProgressDialog::GetObserver(nsIObserver * *aObserver)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsProgressDialog::SetObserver(nsIObserver * aObserver)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIWebBrowserPersist operation; */
NS_IMETHODIMP nsProgressDialog::GetOperation(nsIWebBrowserPersist * *aOperation)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIDOMWindow dialog; */
NS_IMETHODIMP nsProgressDialog::GetDialog(nsIDOMWindow * *aDialog)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIProgressDialog_h__ */
